
<!DOCTYPE html>

<html lang="python">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.18.1: http://docutils.sourceforge.net/" />

    <title>Documentation for genetic algorithm module &#8212; Genetic Bike A 01.07.2022 documentation</title>
    <link rel="stylesheet" type="text/css" href="_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="_static/alabaster.css" />
    <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
    <script src="_static/jquery.js"></script>
    <script src="_static/underscore.js"></script>
    <script src="_static/_sphinx_javascript_frameworks_compat.js"></script>
    <script src="_static/doctools.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Documentation for gen file" href="gen.html" />
    <link rel="prev" title="Welcome to Genetic Bike A&#39;s documentation!" href="index.html" />
   
  <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <section id="documentation-for-genetic-algorithm-module">
<h1>Documentation for genetic algorithm module<a class="headerlink" href="#documentation-for-genetic-algorithm-module" title="Permalink to this heading">¶</a></h1>
<dl class="py function">
<dt class="sig sig-object py" id="genetic_algo.generate_random_coordinates">
<span class="sig-prename descclassname"><span class="pre">genetic_algo.</span></span><span class="sig-name descname"><span class="pre">generate_random_coordinates</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">start_point</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">side_length</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#genetic_algo.generate_random_coordinates" title="Permalink to this definition">¶</a></dt>
<dd><p>Generate a random coordinates!</p>
<p>This function generates a random coordinates for four point inside a square box defined by a start_point point and length of the side</p>
<dl class="simple">
<dt>start_point<span class="classifier">tuple</span></dt><dd><p>Two dimentional point representing a staring point for a square box</p>
</dd>
<dt>side_lenght<span class="classifier">int</span></dt><dd><p>A integer number representing the side lenght of a square pox</p>
</dd>
</dl>
<p>list of tuples
Random coordinates of four points that are inside a square-box that is defined by the input parameters</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="genetic_algo.two_coordinates_are_the_same">
<span class="sig-prename descclassname"><span class="pre">genetic_algo.</span></span><span class="sig-name descname"><span class="pre">two_coordinates_are_the_same</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">coordinates</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#genetic_algo.two_coordinates_are_the_same" title="Permalink to this definition">¶</a></dt>
<dd><p>Checking if there are two coordinates in the given list of coordinates that are identical</p>
<p>This function checks if there are two coordinates in the given list of coordinates that are identical.</p>
<dl class="simple">
<dt>coordinates<span class="classifier">list</span></dt><dd><p>A list of four coordinates, each is [(x1, y1), (x2, y2)]</p>
</dd>
</dl>
<p>Bool
Returns True if there are two identical ones, othereise, False</p>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="genetic_algo.one_coordinate">
<span class="sig-prename descclassname"><span class="pre">genetic_algo.</span></span><span class="sig-name descname"><span class="pre">one_coordinate</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">start_point</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">side_length</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#genetic_algo.one_coordinate" title="Permalink to this definition">¶</a></dt>
<dd><p>Generate a coordinate</p>
<p>This function generates a coordinate.</p>
<dl class="simple">
<dt>start_point<span class="classifier">tuple</span></dt><dd><p>Two dimentional point representing a staring point for a square box</p>
</dd>
<dt>side_lenght<span class="classifier">int</span></dt><dd><p>A integer number representing the side lenght of a square pox</p>
</dd>
</dl>
<p>list of tuples
Random coordinate of one point that is inside a square-box that is defined by the input parameters</p>
</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="genetic_algo.Individual">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">genetic_algo.</span></span><span class="sig-name descname"><span class="pre">Individual</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">coordinates</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#genetic_algo.Individual" title="Permalink to this definition">¶</a></dt>
<dd><p>Indivual of four points</p>
<p>...
Attributes
----------
coordinates: list of tuples</p>
<blockquote>
<div><p>A list contanining four  2D points</p>
</div></blockquote>
<dl class="simple">
<dt>set_coordinates(coordinates)</dt><dd><p>reset Indivual by given coordinatge</p>
</dd>
<dt>set_fitness_score(fitness_score)</dt><dd><p>reset fitness score of individual</p>
</dd>
</dl>
</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="genetic_algo.Population">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">genetic_algo.</span></span><span class="sig-name descname"><span class="pre">Population</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">size</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">start_point</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">side_length</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">fit_func</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#genetic_algo.Population" title="Permalink to this definition">¶</a></dt>
<dd><p>A collection of Individual objects!</p>
<p>...
Attributes
------------
__size: int</p>
<blockquote>
<div><p>private integer that spesify the number of Individual object in a population</p>
</div></blockquote>
<dl class="simple">
<dt>__start_point<span class="classifier">tuples</span></dt><dd><p>private tuple  variable that spesify start point of square-box needed to create individual objects</p>
</dd>
<dt>__side_length: int</dt><dd><p>Private int number that spesify the side length of square-box needed to creeate individual objects</p>
</dd>
<dt>fit_func<span class="classifier">function object</span></dt><dd><p>A function object used to calculate fitness score of individual objects in the population</p>
</dd>
</dl>
<p>population: list of all individual objects</p>
<dl class="simple">
<dt>get_size()</dt><dd><p>get population size</p>
</dd>
<dt>set_population(population)</dt><dd><p>reset the population list to a given population list</p>
</dd>
<dt>average_fitness_score():</dt><dd><p>calculate average fitness score of population</p>
</dd>
<dt>save_population_to_file(filename):</dt><dd><p>save the population data into a json file</p>
</dd>
</dl>
</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="genetic_algo.Genetic_algorithm">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">genetic_algo.</span></span><span class="sig-name descname"><span class="pre">Genetic_algorithm</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">population_size</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">start_point</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">side_length</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">fit_func</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#genetic_algo.Genetic_algorithm" title="Permalink to this definition">¶</a></dt>
<dd><p>Genetic Algorithm</p>
<p>A genetic algorithm (GA) is a form of evolutionary computation 
that is especially suitable for optimization problems. 
Following the process of natural evolution, 
a problem is usually solved by following these main steps:</p>
<p>START
Generate the initial population
Compute fitness
REPEAT</p>
<blockquote>
<div><p>Selection
Crossover
Mutation
Compute fitness</p>
</div></blockquote>
<p>UNTIL population has converged
STOP</p>
<dl class="simple">
<dt>population_size<span class="classifier">int</span></dt><dd><p>the size of the population</p>
</dd>
<dt>start<span class="classifier">tuple</span></dt><dd><p>the starting coordinate</p>
</dd>
<dt>bound: int</dt><dd><p>the side length of the area in which we generate the coordinates of the Individual objects</p>
</dd>
<dt>fit_func: function name</dt><dd><p>the function for calculating the fitness score</p>
</dd>
</dl>
<dl class="py method">
<dt class="sig sig-object py" id="genetic_algo.Genetic_algorithm.crossover">
<span class="sig-name descname"><span class="pre">crossover</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">top_individuals</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#genetic_algo.Genetic_algorithm.crossover" title="Permalink to this definition">¶</a></dt>
<dd><p>Crossover population</p>
<p>Use the genes of two parents and combine them to make up the child's genes.</p>
<p>This function takes in a list of individuals, and returns a list of new generated individuals. 
Each generated individual is produced from two randomly selected individuals 
(let's say A and B) from the input list. 
Each generated one has 50% of the content from A and 50% of the content from B.
The total amount of the generated children is the same as the original population size.</p>
<dl class="simple">
<dt>top_individuals<span class="classifier">list</span></dt><dd><p>a list of Individual objects</p>
</dd>
</dl>
<dl class="simple">
<dt>list</dt><dd><p>a list of Individual objects</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="genetic_algo.Genetic_algorithm.mutation">
<span class="sig-name descname"><span class="pre">mutation</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">population</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">mutation_frequency</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0.2</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#genetic_algo.Genetic_algorithm.mutation" title="Permalink to this definition">¶</a></dt>
<dd><p>shuffle coordinates of individual in a given population</p>
<blockquote>
<div><p>This function takes in a Population object, and modifies the coordinates of 
each individual of the given population.</p>
<dl class="simple">
<dt>top_individuals<span class="classifier">object</span></dt><dd><p>a Population object</p>
</dd>
</dl>
</div></blockquote>
<p>random.randint(start_point[1], start_point[1]+side_length)),</p>
<blockquote>
<div><p>None</p>
</div></blockquote>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="genetic_algo.Genetic_algorithm.run">
<span class="sig-name descname"><span class="pre">run</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#genetic_algo.Genetic_algorithm.run" title="Permalink to this definition">¶</a></dt>
<dd><p>Execute the genetic algorithm.</p>
<p>Return a population, where the difference between the best fitness score and 
the average fitness score is less than 0.5.</p>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="genetic_algo.Genetic_algorithm.selection">
<span class="sig-name descname"><span class="pre">selection</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">population</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">percentage</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0.2</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#genetic_algo.Genetic_algorithm.selection" title="Permalink to this definition">¶</a></dt>
<dd><p>Select top individual</p>
<p>Takes in a Population object and a percentage A%, returns a list of individuals 
which are the top A% of the population that have the highest fitness score.</p>
<dl class="simple">
<dt>population<span class="classifier">object</span></dt><dd><p>a Population object</p>
</dd>
<dt>percentage<span class="classifier">float</span></dt><dd><p>the percentage of the population for the selection</p>
</dd>
</dl>
<dl class="simple">
<dt>list</dt><dd><p>a list of Individual objects</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

</section>


          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="index.html">Genetic Bike A</a></h1>








<h3>Navigation</h3>
<p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul class="current">
<li class="toctree-l1 current"><a class="current reference internal" href="#">Documentation for genetic algorithm module</a></li>
<li class="toctree-l1"><a class="reference internal" href="gen.html">Documentation for gen file</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="index.html">Documentation overview</a><ul>
      <li>Previous: <a href="index.html" title="previous chapter">Welcome to Genetic Bike A's documentation!</a></li>
      <li>Next: <a href="gen.html" title="next chapter">Documentation for gen file</a></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2022, "Gutama Ibrahim Mohammad","Hui Cheng", "Alberto Rovetta","Crystal Din".
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 5.0.2</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.12</a>
      
      |
      <a href="_sources/genetic_algorithm.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>